
execute as @p at @s unless entity @e[type=armor_stand,tag=spawngrimgarbox,distance=..40] run function gd:boss_fight/grimgar/grimgar_cleanup
execute as @a[scores={grimgar6=0..}] unless entity @e[type=evoker,tag=Boss_Grimgar] run scoreboard players set @p evoker_kill 1

kill @e[type=evoker,tag=!Boss_Grimgar]


execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:tipped_arrow",tag:{witchcraft:1b}}]}] at @s run function gd:boss_fight/grimgar/cursed

execute as @e[type=armor_stand,tag=spawngrimgarbox] at @s run particle minecraft:ash ~ ~1 ~ 0.5 2 0.5 0.1 1

execute at @e[type=armor_stand,tag=grimgar_wall] run particle dust_color_transition .1 .4 .9 1 .2 .2 .2 ~ ~.5 ~ .3 2 .3 0 1 force

execute as @e[type=minecraft:evoker,tag=Boss_Grimgar] at @p if entity @e[type=minecraft:evoker,tag=Boss_Grimgar,distance=..10] run scoreboard objectives add grimgar_time1 minecraft.custom:minecraft.play_time


execute unless entity @e[type=minecraft:evoker,tag=Boss_Grimgar,limit=1] run bossbar set fight_grimgar players test
execute if entity @e[type=minecraft:evoker,tag=Boss_Grimgar,limit=1] run bossbar set fight_grimgar players @a
execute store result bossbar minecraft:fight_grimgar value run data get entity @e[type=minecraft:evoker,limit=1,tag=Boss_Grimgar] Health


#####Phase 1
execute as @e[scores={grimgar2=1..}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run tp @e[type=minecraft:evoker,tag=Boss_Grimgar] ~ ~ ~ facing entity @p eyes

execute as @a[scores={grimgar2=1..}] run scoreboard objectives add grimgar_phase1 dummy
execute as @a[scores={grimgar2=1..}] as @p at @s if entity @e[type=skeleton,tag=grimgar_skeleton,distance=..10] run scoreboard objectives add skeleton_kill minecraft.killed:minecraft.skeleton

execute as @a[scores={skeleton_kill=1..}] run scoreboard players add @a grimgar_phase1 1
execute as @a[scores={skeleton_kill=1..}] run scoreboard objectives remove skeleton_kill

execute as @a[scores={grimgar2=10}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run effect give @a[distance=..60] minecraft:mining_fatigue 999 2 true
execute as @a[scores={grimgar2=80}] at @p run summon evoker_fangs ~ ~ ~
execute as @e[scores={grimgar2=80}] at @e[type=evoker_fangs] run effect give @p[distance=..3] minecraft:darkness 3 1 true

execute as @a[scores={grimgar2=160}] at @e[type=armor_stand,tag=spawngrimgar1] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar2=200}] at @e[type=armor_stand,tag=spawngrimgar3] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar2=240}] at @e[type=armor_stand,tag=spawngrimgar5] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar2=280}] at @e[type=armor_stand,tag=spawngrimgar7] run function gd:boss_fight/grimgar/grimgar_skeleton_summon

execute as @a[scores={grimgar2=390}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run playsound minecraft:entity.evoker.prepare_attack ambient @a[distance=..20] ~ ~ ~ 10 2
execute as @a[scores={grimgar2=400..403}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run function gd:boss_fight/grimgar/grimgar_silverfish_summon

execute as @a[scores={grimgar2=380}] as @a[scores={random=1..10}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Devour him!
execute as @a[scores={grimgar2=380}] as @a[scores={random=11..20}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say I have some playmates for you...

execute as @a[scores={grimgar2=800}] at @p run summon evoker_fangs ~ ~ ~
execute as @e[scores={grimgar2=800}] at @e[type=evoker_fangs] run effect give @p[distance=..3] minecraft:darkness 3 1 true

execute as @a[scores={grimgar2=880}] at @e[type=armor_stand,tag=spawngrimgar2] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar2=920}] at @e[type=armor_stand,tag=spawngrimgar4] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar2=960}] at @e[type=armor_stand,tag=spawngrimgar6] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar2=100}] at @e[type=armor_stand,tag=spawngrimgar8] run function gd:boss_fight/grimgar/grimgar_skeleton_summon

execute as @a[scores={grimgar2=800..803}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run function gd:boss_fight/grimgar/grimgar_silverfish_summon

execute as @a[scores={grimgar2=1020..}] run scoreboard players set @p grimgar2 1

execute as @a[scores={grimgar_phase1=16}] run bossbar set fight_grimgar max 600
execute as @a[scores={grimgar_phase1=15}] run bossbar set fight_grimgar max 581
execute as @a[scores={grimgar_phase1=14}] run bossbar set fight_grimgar max 562
execute as @a[scores={grimgar_phase1=13}] run bossbar set fight_grimgar max 544
execute as @a[scores={grimgar_phase1=12}] run bossbar set fight_grimgar max 525
execute as @a[scores={grimgar_phase1=11}] run bossbar set fight_grimgar max 506
execute as @a[scores={grimgar_phase1=10}] run bossbar set fight_grimgar max 487
execute as @a[scores={grimgar_phase1=9}] run bossbar set fight_grimgar max 469
execute as @a[scores={grimgar_phase1=8}] run bossbar set fight_grimgar max 450
execute as @a[scores={grimgar_phase1=7}] run bossbar set fight_grimgar max 431
execute as @a[scores={grimgar_phase1=6}] run bossbar set fight_grimgar max 412
execute as @a[scores={grimgar_phase1=5}] run bossbar set fight_grimgar max 394
execute as @a[scores={grimgar_phase1=4}] run bossbar set fight_grimgar max 375
execute as @a[scores={grimgar_phase1=3}] run bossbar set fight_grimgar max 356
execute as @a[scores={grimgar_phase1=2}] run bossbar set fight_grimgar max 337
execute as @a[scores={grimgar_phase1=1}] run bossbar set fight_grimgar max 319

execute as @a[scores={grimgar_phase1=16..}] run scoreboard objectives add grimgar3 minecraft.custom:minecraft.play_time

execute as @a[scores={grimgar_phase1=16..}] run scoreboard objectives remove grimgar_phase1

execute at @e[type=minecraft:silverfish,tag=grimgar_silverfish] run particle dust_color_transition .1 .1 .2 1 .2 .2 .2 ~ ~.5 ~ .1 .1 .1 0 1 force


#####Phase 2
execute as @e[scores={grimgar4=1..}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run tp @e[type=minecraft:evoker,tag=Boss_Grimgar] ~ ~ ~ facing entity @p eyes
execute as @a[scores={grimgar4=0..}] run kill @e[type=wither_skeleton,tag=!grimgar_wither_skeleton]
execute as @a[scores={grimgar4=0..}] as @p at @s unless entity @e[type=wither_skeleton,tag=grimgar_wither_skeleton] run scoreboard players set @p wither_skeleton_kill 1

execute unless entity @e[type=minecraft:wither_skeleton,tag=grimgar_wither_skeleton,limit=1] run bossbar set fight_deathlord players test
execute if entity @e[type=minecraft:wither_skeleton,tag=grimgar_wither_skeleton,limit=1] run bossbar set fight_deathlord players @a
execute store result bossbar minecraft:fight_deathlord value run data get entity @e[type=minecraft:wither_skeleton,tag=grimgar_wither_skeleton,limit=1] Health

execute as @a[scores={grimgar4=1..}] run scoreboard objectives add grimgar_phase2 dummy
execute as @a[scores={grimgar4=1..}] as @p at @s if entity @e[type=wither_skeleton,tag=grimgar_wither_skeleton,distance=..10] run scoreboard objectives add wither_skeleton_kill minecraft.killed:minecraft.wither_skeleton

execute as @a[scores={wither_skeleton_kill=1..}] run scoreboard players add @a grimgar_phase2 1
execute as @a[scores={wither_skeleton_kill=1..}] run scoreboard objectives remove wither_skeleton_kill

execute as @e[type=minecraft:armor_stand,tag=skull_grimgar] run function gd:boss_fight/grimgar/grimgar_skull_hit
execute as @e[type=minecraft:armor_stand,tag=skull_grimgar] run function gd:boss_fight/grimgar/grimgar_skull

execute as @a[scores={skull_time_grimgar=25..}] at @e[type=armor_stand,tag=skull_grimgar] run playsound minecraft:entity.vex.death player @a[distance=..10] ~ ~ ~ 10 1
execute as @a[scores={skull_time_grimgar=25..}] at @e[type=armor_stand,tag=skull_grimgar] run particle sonic_boom ~ ~1 ~ .1 .1 .1 0.01 1 force
execute as @a[scores={skull_time_grimgar=25..}] run kill @e[type=armor_stand,tag=skull_grimgar]
execute as @a[scores={skull_time_grimgar=25..}] run scoreboard objectives remove skull_time_grimgar

execute as @a[scores={grimgar4=10}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run effect give @a[distance=..60] minecraft:mining_fatigue 999 2 true
execute as @e[scores={grimgar4=60}] run effect give @e[type=wither_skeleton,tag=grimgar_wither_skeleton] minecraft:instant_damage 1 3 true
execute as @a[scores={grimgar4=60}] at @e[type=wither_skeleton,tag=grimgar_wither_skeleton] run playsound minecraft:item.goat_horn.sound.2 ambient @a[distance=..15] ~ ~ ~ 10 0.5

execute as @a[scores={grimgar4=80}] at @p run summon evoker_fangs ~ ~ ~
execute as @e[scores={grimgar4=800}] at @e[type=evoker_fangs] run effect give @p[distance=..3] minecraft:darkness 3 1 true

execute as @a[scores={grimgar4=160}] at @e[type=armor_stand,tag=spawngrimgar1] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar4=200}] at @e[type=armor_stand,tag=spawngrimgar3] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar4=240}] at @e[type=armor_stand,tag=spawngrimgar5] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar4=280}] at @e[type=armor_stand,tag=spawngrimgar7] run function gd:boss_fight/grimgar/grimgar_skeleton_summon

execute as @e[scores={grimgar4=360}] run effect give @e[type=wither_skeleton,tag=grimgar_wither_skeleton] minecraft:speed 3 2 true
execute as @a[scores={grimgar4=360}] at @e[type=wither_skeleton,tag=grimgar_wither_skeleton] run playsound minecraft:entity.enderman.scream ambient @a[distance=..15] ~ ~ ~ 10 0.3
execute as @a[scores={grimgar4=360}] at @e[type=wither_skeleton,tag=grimgar_wither_skeleton] run particle minecraft:large_smoke ~ ~1 ~ 0.1 0.1 0.1 0.07 100

execute as @a[scores={grimgar4=400}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run function gd:boss_fight/grimgar/grimgar_skull_summon
execute as @a[scores={grimgar4=900}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run function gd:boss_fight/grimgar/grimgar_skull_summon

execute as @a[scores={grimgar4=380}] as @a[scores={random=1..10}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Oh oh, now it gets interesting. Muahahahaha!
execute as @a[scores={grimgar4=880}] as @a[scores={random=1..10}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Something is chasing you... and you can't run away!
execute as @a[scores={grimgar4=380}] as @a[scores={random=11..20}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Take that! 
execute as @a[scores={grimgar4=880}] as @a[scores={random=11..20}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Something is chasing you... and you can't run away!

execute as @a[scores={grimgar4=800}] at @p run summon evoker_fangs ~ ~ ~
execute as @e[scores={grimgar4=800}] at @e[type=evoker_fangs] run effect give @p[distance=..3] minecraft:darkness 3 1 true

execute as @a[scores={grimgar4=880}] at @e[type=armor_stand,tag=spawngrimgar2] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar4=920}] at @e[type=armor_stand,tag=spawngrimgar4] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar4=960}] at @e[type=armor_stand,tag=spawngrimgar6] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar4=1000}] at @e[type=armor_stand,tag=spawngrimgar8] run function gd:boss_fight/grimgar/grimgar_skeleton_summon

execute as @e[scores={grimgar4=1010}] run effect give @e[type=wither_skeleton,tag=grimgar_wither_skeleton] minecraft:speed 3 2 true
execute as @a[scores={grimgar4=1010}] at @e[type=wither_skeleton,tag=grimgar_wither_skeleton] run playsound minecraft:entity.enderman.scream ambient @a[distance=..15] ~ ~ ~ 10 0.3
execute as @a[scores={grimgar4=1010}] at @e[type=wither_skeleton,tag=grimgar_wither_skeleton] run execute run particle minecraft:large_smoke ~ ~1 ~ 0.1 0.1 0.1 0.07 100

execute as @a[scores={grimgar4=1020..}] run scoreboard players set @p grimgar4 1

execute as @a[scores={grimgar_phase2=1}] run bossbar set fight_grimgar max 900

execute as @a[scores={grimgar_phase2=1..}] run scoreboard objectives add grimgar5 minecraft.custom:minecraft.play_time

execute as @a[scores={grimgar_phase2=1..}] run scoreboard objectives remove grimgar_phase2

#####Phase 3
execute as @a[scores={grimgar6=10}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run effect give @a[distance=..60] minecraft:mining_fatigue 999 2 true
execute as @a[scores={grimgar6=80}] at @p run summon evoker_fangs ~ ~ ~
execute as @a[scores={grimgar6=100}] at @p run summon evoker_fangs ~ ~ ~
execute as @e[scores={grimgar6=80}] at @e[type=evoker_fangs] run effect give @p[distance=..3] minecraft:darkness 3 1 true


execute as @e[scores={grimgar6=80}] run effect give @e[type=minecraft:evoker,tag=Boss_Grimgar] minecraft:regeneration 5 3 true

execute as @a[scores={grimgar6=160}] at @e[type=armor_stand,tag=spawngrimgar1] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar6=200}] at @e[type=armor_stand,tag=spawngrimgar4] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar6=240}] at @e[type=armor_stand,tag=spawngrimgar5] run function gd:boss_fight/grimgar/grimgar_skeleton_summon
execute as @a[scores={grimgar6=280}] at @e[type=armor_stand,tag=spawngrimgar8] run function gd:boss_fight/grimgar/grimgar_skeleton_summon

execute as @a[scores={grimgar6=400}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run function gd:boss_fight/grimgar/grimgar_skull_summon
execute as @a[scores={grimgar6=900}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run function gd:boss_fight/grimgar/grimgar_skull_summon

execute as @a[scores={grimgar6=380}] as @a[scores={random=1..10}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Gotcha little kitten.
execute as @a[scores={grimgar6=880}] as @a[scores={random=1..10}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say You will not defeat me!
execute as @a[scores={grimgar6=380}] as @a[scores={random=11..20}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Oh oh, now it gets interesting. Muahahahaha!
execute as @a[scores={grimgar6=880}] as @a[scores={random=11..20}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Are you getting tired?

execute as @a[scores={grimgar6=800}] at @p run summon evoker_fangs ~ ~ ~
execute as @a[scores={grimgar6=820}] at @p run summon evoker_fangs ~ ~ ~
execute as @e[scores={grimgar6=800}] at @e[type=evoker_fangs] run effect give @p[distance=..3] minecraft:darkness 3 1 true

execute as @e[scores={grimgar6=1000..1020}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run particle dust_color_transition .0 .0 .1 1 .2 .2 .2 ~ ~1 ~ .5 .6 .5 0 50 force
execute as @e[scores={grimgar6=0..20}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run particle dust_color_transition .0 .0 .1 1 .2 .2 .2 ~ ~1 ~ .5 .6 .5 0 50 force
execute as @a[scores={grimgar6=1010}] run tp @e[type=minecraft:evoker,tag=Boss_Grimgar] @p
execute as @a[scores={grimgar6=980}] run playsound minecraft:entity.evoker.cast_spell master @a ~ ~ ~ 10 0.0001


execute as @a[scores={grimgar6=1020..}] run scoreboard players set @p grimgar6 1

execute as @e[type=armor_stand,tag=spawngrimgarbox] at @s run particle dust_color_transition .0 .0 .0 1 .2 .2 .2 ~ ~3 ~ .2 1 .2 0 30 force







