#####Spawn
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:tipped_arrow",tag:{witchcraft:1b}}]}] at @s run function gd:boss_fight/grimgar/cursed

kill @e[type=evoker,tag=!Boss_Grimgar]

scoreboard objectives add grimgar_playerdeath minecraft.custom:minecraft.deaths

execute as @a[scores={grimgar1=1}] run playsound minecraft:skellige_battle_grimgar record @a[distance=..30] ~ ~1 ~ 50
execute as @a[scores={grimgar1=1}] at @e[type=armor_stand,tag=spawngrimgar] run summon armor_stand ~ ~ ~ {Invisible:1b,Marker:1b,Small:1b,Invulnerable:1b,NoGravity:1b,CustomName:'[{"text":"Grimgar the Ferocious Bugbear","color":"#009999"}]',Tags:["spawngrimgarbox","boss_marker"]}
execute as @a[scores={grimgar1=1}] run kill @e[type=armor_stand,tag=spawngrimgar]

execute as @e[scores={grimgar1=1}] at @e[type=armor_stand,tag=grimgar_wall] run setblock ~ ~ ~ barrier
execute as @e[scores={grimgar1=1}] at @e[type=armor_stand,tag=grimgar_wall] run setblock ~ ~1 ~ barrier
execute as @e[scores={grimgar1=1}] at @e[type=armor_stand,tag=grimgar_wall] run setblock ~ ~2 ~ barrier
execute as @e[scores={grimgar1=1..}] at @e[type=armor_stand,tag=grimgar_wall] run particle dust_color_transition .1 .4 .9 1 .2 .2 .2 ~ ~.5 ~ .1 2 .1 0 1 force
execute as @e[scores={grimgar3=1..}] at @e[type=armor_stand,tag=grimgar_wall] run particle dust_color_transition .1 .4 .9 1 .2 .2 .2 ~ ~.5 ~ .1 2 .1 0 1 force
execute as @e[scores={grimgar5=1..}] at @e[type=armor_stand,tag=grimgar_wall] run particle dust_color_transition .1 .4 .9 1 .2 .2 .2 ~ ~.5 ~ .1 2 .1 0 1 force

execute as @e[scores={grimgar1=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run effect give @a[distance=..30] minecraft:darkness 15 1 true
execute as @e[scores={grimgar1=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run effect give @a[distance=..30] minecraft:slowness 7 2 true
execute as @e[scores={grimgar1=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run effect give @a[distance=..60] minecraft:mining_fatigue 999 2 true

execute as @e[scores={grimgar1=10}] at @e[type=armor_stand,tag=spawngrimgarbox] at @a[distance=..60,limit=1,sort=nearest] run say Something changed. I feel weird, weak.. What's happening here? What the...


execute as @e[scores={grimgar1=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.enderman.stare ambient @a[distance=..20] ~ ~ ~ 10 2
execute as @e[scores={grimgar1=40}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.lightning_bolt.thunder ambient @a[distance=..20] ~ ~ ~ 10 2
execute as @e[scores={grimgar1=80}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.lightning_bolt.thunder ambient @a[distance=..20] ~ ~ ~ 10 2
execute as @e[scores={grimgar1=70}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.ravager.roar ambient @a[distance=..20] ~ ~ ~ 10 0.5
execute as @e[scores={grimgar1=90}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:bells ambient @a[distance=..20] ~ ~ ~ 10 1
execute as @e[scores={grimgar1=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle dust_color_transition .0 .0 .1 1 .2 .2 .2 ~ ~4 ~ .1 3 .1 0 15 force
execute as @e[scores={grimgar1=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle minecraft:electric_spark ~ ~4 ~ 0.7 2 0.7 0.5 10
execute as @e[scores={grimgar1=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle minecraft:warped_spore ~ ~4 ~ 0.1 2 0.1 0.5 10
execute as @e[scores={grimgar1=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle dust_color_transition .0 .0 .3 1 .2 .2 .2 ~ ~4 ~ .5 .6 .5 0 15 force

execute as @e[scores={grimgar1=90}] at @e[type=armor_stand,tag=spawngrimgarbox,sort=nearest,limit=1] run summon evoker ~ ~3 ~ {SpellTicks:100,CustomName:'[{"text":"Grimgar the Ferocious Bugbear","color":"#009999"}]',Health:300,PersistenceRequired:1b,Invulnerable:1b,NoAI:1b,NoGravity:1b,Tags:["Boss_Grimgar"],ActiveEffects:[{Id:10,Duration:99999,Amplifier:9,ShowParticles:0b}],ArmorItems:[{},{},{},{id:skeleton_skull,tag:{AttributeModifiers:[{AttributeName:"generic.armor",Amount:10,Slot:head,Name:"generic.armor",UUID:[I;-123715,22770,215522,-45540]}],display:{Name:'[{"text":"Grimgar\'s Necromacer Mask ","italic":true,"color":"#660000"}]',Lore:['[{"text":"Irrefutable proof, that Grimgar","italic":false,"color":"gray"}]','[{"text":"has been vanquished.","italic":false,"color":"gray"}]']},Enchantments:[{id:binding_curse,lvl:1}],HideFlags:2},Count:1}],Attributes:[{Name:"generic.follow_range",Base:60f},{Name:"generic.armor",Base:10f},{Name:"generic.armor_toughness",Base:5f},{Name:"generic.max_health",Base:300f}],ArmorDropChances:[0f,0f,0f,0f]}

execute as @a[scores={grimgar1=1}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Argh, another new challenger? Pathetic.
execute as @a[scores={grimgar1=90}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say My undead minions will take care of you.. I don't have time for this.

execute as @a[scores={grimgar1=90}] run bossbar add fight_grimgar {"text":"Grimgar the Ferocious Bugbear","color":"gray","bold":true}
execute as @a[scores={grimgar1=90}] run bossbar set fight_grimgar style notched_12
execute as @a[scores={grimgar1=90}] run bossbar set fight_grimgar color blue
execute as @a[scores={grimgar1=90}] run bossbar set fight_grimgar max 300
execute as @a[scores={grimgar1=90}] run bossbar set fight_grimgar value 300
execute as @a[scores={grimgar1=90}] run scoreboard objectives add evoker_kill minecraft.killed:minecraft.evoker

execute as @e[scores={grimgar1=90}] run scoreboard objectives add grimgar2 minecraft.custom:minecraft.play_time

execute as @a[scores={grimgar1=100..}] run scoreboard objectives remove grimgar1

execute as @e[scores={grimgar3=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run effect give @a[distance=..60] minecraft:mining_fatigue 999 2 true

#execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run setblock ~ ~1 ~ air
#execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run setblock ~1 ~1 ~ air
#execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run setblock ~ ~1 ~1 air
#execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run setblock ~-1 ~1 ~ air
#execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run setblock ~ ~1 ~-1 air
execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:ambient.soul_sand_valley.mood master @a[distance=..20] ~ ~ ~ 10 2
execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:ambient.warped_forest.mood master @a[distance=..20] ~ ~ ~ 8 2
execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:ambient.warped_forest.mood master @a[distance=..20] ~ ~ ~ 8 2
execute as @e[scores={grimgar3=50}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:ambient.warped_forest.mood master @a[distance=..20] ~ ~ ~ 8 2

execute as @a[scores={grimgar3=1}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say I see you're not that easy to eliminate.
execute as @a[scores={grimgar3=90}] as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Let's see how long you last against one of my champions.

execute as @e[scores={grimgar3=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.ravager.hurt ambient @a[distance=..20] ~ ~ ~ 10 1.5
execute as @e[scores={grimgar3=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.enderman.stare ambient @a[distance=..20] ~ ~ ~ 10 2
execute as @e[scores={grimgar3=70}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.ravager.roar ambient @a[distance=..20] ~ ~ ~ 10 0.5
#####execute as @e[scores={grimgar3=90}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:bells ambient @a[distance=..20] ~ ~ ~ 10 1
execute as @e[scores={grimgar3=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle dust_color_transition .0 .0 .1 1 .2 .2 .2 ~ ~4 ~ .1 3 .1 0 15 force
execute as @e[scores={grimgar3=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle minecraft:end_rod ~ ~4 ~ 0.7 2 0.7 0.5 10
execute as @e[scores={grimgar3=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle minecraft:warped_spore ~ ~4 ~ 0.1 2 0.1 0.5 10
execute as @e[scores={grimgar3=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle dust_color_transition .0 .0 .3 1 .2 .2 .2 ~ ~4 ~ .5 .6 .5 0 15 force
execute as @e[scores={grimgar3=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run scoreboard objectives add grimgar4 minecraft.custom:minecraft.play_time

execute as @e[scores={grimgar3=90}] at @e[type=armor_stand,tag=spawngrimgarbox] run function gd:boss_fight/grimgar/grimgar_wither_skeleton_summon

execute as @a[scores={grimgar3=90}] run bossbar add fight_deathlord {"text":"Undead Deathlord","color":"dark_gray","bold":true}
execute as @a[scores={grimgar3=90}] run bossbar set fight_deathlord style notched_6
execute as @a[scores={grimgar3=90}] run bossbar set fight_deathlord color red
execute as @a[scores={grimgar3=90}] run bossbar set fight_deathlord max 300
execute as @a[scores={grimgar3=90}] run bossbar set fight_deathlord value 300



execute as @a[scores={grimgar3=100..}] run scoreboard objectives remove grimgar3
execute as @a[scores={grimgar4=1..}] run scoreboard objectives remove grimgar2

execute as @e[scores={grimgar5=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run effect give @a[distance=..60] minecraft:mining_fatigue 999 2 true

execute as @e[scores={grimgar5=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.ravager.hurt ambient @a[distance=..20] ~ ~ ~ 10 1.5
execute as @e[scores={grimgar5=1}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.enderman.stare ambient @a[distance=..20] ~ ~ ~ 10 2
execute as @e[scores={grimgar5=40}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.lightning_bolt.thunder ambient @a[distance=..20] ~ ~ ~ 10 2
execute as @e[scores={grimgar5=80}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.lightning_bolt.thunder ambient @a[distance=..20] ~ ~ ~ 10 2
execute as @e[scores={grimgar5=70}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.ravager.roar ambient @a[distance=..20] ~ ~ ~ 10 0.5
#####execute as @e[scores={grimgar5=90}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:bells ambient @a[distance=..20] ~ ~ ~ 10 1
execute as @e[scores={grimgar5=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle dust_color_transition .0 .0 .1 1 .2 .2 .2 ~ ~4 ~ .1 3 .1 0 15 force
execute as @e[scores={grimgar5=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle minecraft:end_rod ~ ~4 ~ 0.7 2 0.7 0.5 10
execute as @e[scores={grimgar5=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle minecraft:warped_spore ~ ~4 ~ 0.1 2 0.1 0.5 10
execute as @e[scores={grimgar5=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle dust_color_transition .0 .0 .3 1 .2 .2 .2 ~ ~4 ~ .5 .6 .5 0 15 force
execute as @e[scores={grimgar5=..90}] at @e[type=armor_stand,tag=spawngrimgarbox] run scoreboard objectives add grimgar6 minecraft.custom:minecraft.play_time
execute as @e[scores={grimgar5=90}] at @e[type=armor_stand,tag=spawngrimgarbox] run playsound minecraft:entity.ravager.roar ambient @a[distance=..20] ~ ~ ~ 10 1.5


execute as @e[scores={grimgar5=90}] at @e[type=armor_stand,tag=spawngrimgarbox] run particle minecraft:explosion ~ ~4 ~ 0.3 1 0.3 1 100

execute as @a[scores={grimgar5=90}] at @e[type=minecraft:evoker,tag=Boss_Grimgar] run tp @e[type=minecraft:evoker,tag=Boss_Grimgar] ~ ~-10 ~
execute as @e[scores={grimgar5=90}] run kill @e[type=minecraft:evoker,tag=Boss_Grimgar]
execute as @e[scores={grimgar5=90}] at @e[type=armor_stand,tag=spawngrimgarbox,sort=nearest,limit=1] run summon evoker ~ ~3 ~ {SpellTicks:100,CustomName:'[{"text":"Grimgar the Ferocious Bugbear","color":"#009999"}]',Health:300,PersistenceRequired:1b,Tags:["Boss_Grimgar"],ActiveEffects:[{Id:28,Duration:40,ShowParticles:0b}],HandItems:[{id:diamond_sword,tag:{display:{Name:'[{"text":"Heavy Greatsword","italic":false}]'}},Count:1},{id:totem_of_undying,Count:3}],ArmorItems:[{},{},{},{id:skeleton_skull,tag:{AttributeModifiers:[{AttributeName:"generic.armor",Amount:10,Slot:head,Name:"generic.armor",UUID:[I;-123715,22770,215522,-45540]}],display:{Name:'[{"text":"Grimgar\'s Necromacer Mask ","italic":true,"color":"#660000"}]',Lore:['[{"text":"Irrefutable proof, that Grimgar","italic":false,"color":"gray"}]','[{"text":"has been vanquished.","italic":false,"color":"gray"}]']},Enchantments:[{id:binding_curse,lvl:1}],HideFlags:2},Count:1}],ArmorDropChances:[0f,0f,0f,0f],Attributes:[{Name:"generic.follow_range",Base:60f},{Name:"generic.armor",Base:10f},{Name:"generic.armor_toughness",Base:5f},{Name:"generic.max_health",Base:300f}],HandDropChances:[0f,0f]}

execute as @a[scores={grimgar5=1}] run execute as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say Ahhhhhrg! Buggers like you bother me here over and over again! 
execute as @a[scores={grimgar5=90}] run execute as @e[type=minecraft:evoker,tag=Boss_Grimgar] run say None of your predecessors will ever bother anyone again and now it's time for you to... "disappear".

execute as @a[scores={grimgar5=100..}] run scoreboard objectives remove grimgar5
execute as @a[scores={grimgar6=1..}] run scoreboard objectives remove grimgar4


execute as @e[type=armor_stand,tag=spawngrimgarbox] run execute at @s run particle dust_color_transition .0 .0 .0 1 .2 .2 .2 ~ ~3 ~ .2 1 .2 0 30 force

execute as @e[type=armor_stand,tag=spawngrimgar] run execute at @s run particle dust_color_transition .0 .0 .0 1 .2 .2 .2 ~ ~3 ~ .2 1 .2 0 30 force
