
playsound minecraft:entity.ravager.death ambient @a[distance=..30] ~ ~ ~ 20 1.5

playsound minecraft:ui.toast.challenge_complete master @a ~ ~1 ~ 20 1
title @a title [{"text":"GREAT ENEMY FELLED","color":"dark_red"}]
execute at @e[type=armor_stand,tag=spawngrimgarbox] at @a[distance=..60] run summon minecraft:experience_orb ~ ~3 ~ {Value:640,Count:12}

execute at @p run summon armor_stand ~ ~ ~ {Invisible:1b,CustomName:'[{"text":"Grimgar the Ferocious Bugbear","color":"#009999"}]',Tags:["grimgar_death","boss_marker"]}

execute at @e[type=armor_stand,tag=spawngrimgarbox] run summon minecraft:item ~ ~1 ~ {Item:{id:"minecraft:skeleton_skull",Count:1b,tag:{AttributeModifiers:[{AttributeName:"generic.armor",Amount:10,Slot:head,Name:"generic.armor",UUID:[I;-123715,22770,215522,-45540]}],display:{Name:'[{"text":"Grimgar\'s Necromacer Mask ","italic":true,"color":"#660000"}]',Lore:['[{"text":"Irrefutable proof, that Grimgar","italic":false,"color":"gray"}]','[{"text":"has been vanquished.","italic":false,"color":"gray"}]']},Enchantments:[{id:binding_curse,lvl:1}],HideFlags:2}},Motion:[0.0,0.3,0.0]} 

execute as @e[type=armor_stand,tag=grimgar_death] run say That's impossible! You cannot defeat me, I have the power of the gods! And you're just a pathetic... arrggh..
execute at @e[type=armor_stand,tag=spawngrimgarbox] at @a[distance=..60,limit=1,sort=nearest] run say Apparently, not as strong as you thought.. 
execute at @e[type=armor_stand,tag=spawngrimgarbox] at @a[distance=..60,limit=1,sort=nearest] run say Maybe someone will pay me well for his mask...

function gd:boss_fight/grimgar/grimgar_cleanup

kill @e[type=armor_stand,tag=grimgar_wall]
kill @e[type=armor_stand,tag=spawngrimgar1]
kill @e[type=armor_stand,tag=spawngrimgar2]
kill @e[type=armor_stand,tag=spawngrimgar3]
kill @e[type=armor_stand,tag=spawngrimgar4]
kill @e[type=armor_stand,tag=spawngrimgar5]
kill @e[type=armor_stand,tag=spawngrimgar6]
kill @e[type=armor_stand,tag=spawngrimgar7]
kill @e[type=armor_stand,tag=spawngrimgar8]

scoreboard objectives remove grimgar1
scoreboard objectives remove grimgar2
scoreboard objectives remove grimgar3
scoreboard objectives remove grimgar4
scoreboard objectives remove grimgar5
scoreboard objectives remove grimgar6
scoreboard objectives remove grimgar_phase1
scoreboard objectives remove grimgar_phase2
scoreboard objectives remove skull_attack_grimgar
scoreboard objectives remove skull_time_grimgar
kill @e[type=armor_stand,tag=skull_grimgar]


kill @e[type=armor_stand,tag=spawngrimgarbox]

execute at @e[type=armor_stand,tag=spawngrimgar_villager] run summon villager ~ ~ ~ {VillagerData:{type:plains,profession:librarian,level:2},CustomName:'[{"text":"Humble Monk","color":"#996600"}]',Health:30,Attributes:[{Name:"generic.movement_speed",Base:0.4f},{Name:"generic.max_health",Base:30f}]}
execute at @e[type=armor_stand,tag=spawngrimgar_villager] run summon villager ~ ~ ~ {VillagerData:{type:plains,profession:librarian,level:2},CustomName:'[{"text":"Humble Monk","color":"#996600"}]',Health:30,Attributes:[{Name:"generic.movement_speed",Base:0.4f},{Name:"generic.max_health",Base:30f}]}

execute at @e[type=armor_stand,tag=spawngrimgar_trader] run summon villager ~ ~ ~ {VillagerData:{type:plains,profession:cleric,level:3},Offers:{Recipes:[{maxUses:16,buy:{id:book,Count:24},sell:{id:iron_nugget,Count:1,tag:{silver_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Silver Coin","color":"gray"}]'}}}},{maxUses:1,buy:{id:gold_nugget,Count:6,tag:{gold_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Gold Coin","color":"gold"}]'}}},sell:{id:enchanted_book,Count:1,tag:{elder_tome:1b,display:{Name:'[{"text":"Elder Tome","italic":false,"color":"#9900cc"}]',Lore:['[{"text":"Encrusted with the knowledge of","italic":false,"color":"gray"}]','[{"text":"ages past, their pages whisper","italic":false,"color":"gray"}]','[{"text":"secrets long forgotten and","italic":false,"color":"gray"}]','[{"text":"mysteries yet unraveled. Seekers","italic":false,"color":"gray"}]','[{"text":"of wisdom and fortune venture","italic":false,"color":"gray"}]','[{"text":"forth, for within these venerable","italic":false,"color":"gray"}]','[{"text":"texts, the keys to untold power","italic":false,"color":"gray"}]','[{"text":"and untamed magic await the daring","italic":false,"color":"gray"}]','[{"text":"hand that dares to grasp them.","italic":false,"color":"gray"}]']},StoredEnchantments:[{id:"minecraft:fortune",lvl:3}]}}},{maxUses:1,buy:{id:gold_nugget,Count:6,tag:{gold_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Gold Coin","color":"gold"}]'}}},sell:{id:enchanted_book,Count:1,tag:{elder_tome:1b,display:{Name:'[{"text":"Ancient Scriptures","italic":false,"color":"#9900cc"}]',Lore:['[{"text":"Encrusted with the knowledge of","italic":false,"color":"gray"}]','[{"text":"ages past, their pages whisper","italic":false,"color":"gray"}]','[{"text":"secrets long forgotten and","italic":false,"color":"gray"}]','[{"text":"mysteries yet unraveled. Seekers","italic":false,"color":"gray"}]','[{"text":"of wisdom and fortune venture","italic":false,"color":"gray"}]','[{"text":"forth, for within these venerable","italic":false,"color":"gray"}]','[{"text":"texts, the keys to untold power","italic":false,"color":"gray"}]','[{"text":"and untamed magic await the daring","italic":false,"color":"gray"}]','[{"text":"hand that dares to grasp them.","italic":false,"color":"gray"}]']},StoredEnchantments:[{id:"minecraft:looting",lvl:3}]}}},{maxUses:1,buy:{id:gold_nugget,Count:6,tag:{gold_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Gold Coin","color":"gold"}]'}}},sell:{id:enchanted_book,Count:1,tag:{elder_tome:1b,display:{Name:'[{"text":"Hoary Scrolls","italic":false,"color":"#9900cc"}]',Lore:['[{"text":"Encrusted with the knowledge of","italic":false,"color":"gray"}]','[{"text":"ages past, their pages whisper","italic":false,"color":"gray"}]','[{"text":"secrets long forgotten and","italic":false,"color":"gray"}]','[{"text":"mysteries yet unraveled. Seekers","italic":false,"color":"gray"}]','[{"text":"of wisdom and fortune venture","italic":false,"color":"gray"}]','[{"text":"forth, for within these venerable","italic":false,"color":"gray"}]','[{"text":"texts, the keys to untold power","italic":false,"color":"gray"}]','[{"text":"and untamed magic await the daring","italic":false,"color":"gray"}]','[{"text":"hand that dares to grasp them.","italic":false,"color":"gray"}]']},StoredEnchantments:[{id:"minecraft:power",lvl:5}]}}},{maxUses:1,buy:{id:gold_nugget,Count:6,tag:{gold_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Gold Coin","color":"gold"}]'}}},sell:{id:enchanted_book,Count:1,tag:{elder_tome:1b,display:{Name:'[{"text":"Cursed Writings","italic":false,"color":"#9900cc"}]',Lore:['[{"text":"Encrusted with the knowledge of","italic":false,"color":"gray"}]','[{"text":"ages past, their pages whisper","italic":false,"color":"gray"}]','[{"text":"secrets long forgotten and","italic":false,"color":"gray"}]','[{"text":"mysteries yet unraveled. Seekers","italic":false,"color":"gray"}]','[{"text":"of wisdom and fortune venture","italic":false,"color":"gray"}]','[{"text":"forth, for within these venerable","italic":false,"color":"gray"}]','[{"text":"texts, the keys to untold power","italic":false,"color":"gray"}]','[{"text":"and untamed magic await the daring","italic":false,"color":"gray"}]','[{"text":"hand that dares to grasp them.","italic":false,"color":"gray"}]']},StoredEnchantments:[{id:"minecraft:protection",lvl:4}]}}},{maxUses:1,buy:{id:gold_nugget,Count:6,tag:{gold_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Gold Coin","color":"gold"}]'}}},sell:{id:enchanted_book,Count:1,tag:{elder_tome:1b,display:{Name:'[{"text":"Dusty Notices","italic":false,"color":"#9900cc"}]',Lore:['[{"text":"Encrusted with the knowledge of","italic":false,"color":"gray"}]','[{"text":"ages past, their pages whisper","italic":false,"color":"gray"}]','[{"text":"secrets long forgotten and","italic":false,"color":"gray"}]','[{"text":"mysteries yet unraveled. Seekers","italic":false,"color":"gray"}]','[{"text":"of wisdom and fortune venture","italic":false,"color":"gray"}]','[{"text":"forth, for within these venerable","italic":false,"color":"gray"}]','[{"text":"texts, the keys to untold power","italic":false,"color":"gray"}]','[{"text":"and untamed magic await the daring","italic":false,"color":"gray"}]','[{"text":"hand that dares to grasp them.","italic":false,"color":"gray"}]']},StoredEnchantments:[{id:"minecraft:sharpness",lvl:5}]}}},{maxUses:1,buy:{id:gold_nugget,Count:12,tag:{gold_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Gold Coin","color":"gold"}]'}}},sell:{id:warped_fungus_on_a_stick,Count:1,tag:{wither_skull_staff:1b,display:{Name:'[{"text":"Cursed Bonecaller","italic":false,"color":"#330066"}]',Lore:['[{"text":"Conjures a wither skull around","italic":false,"color":"gray"}]','[{"text":"the caster.","italic":false,"color":"gray"}]']}}}},{maxUses:1,buy:{id:gold_nugget,Count:32,tag:{gold_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Gold Coin","color":"gold"}]'}}},sell:{id:echo_shard,Count:1,tag:{artifact_2:1b,display:{Name:'["",{"text":"Evasive Shard","italic":false,"color":"#339966"}]',Lore:['["",{"text":"♦ Artifact ♦","italic":false,"color":"gray"}]','["",{"text":"Prevents the wearer from entering","italic":false,"color":"gray"}]','["",{"text":"any boss fight, when held in the","italic":false,"color":"gray"}]','["",{"text":"offhand.","italic":false,"color":"gray"}]']},Enchantments:[{lvl:1,id:vanishing_curse}]}}}]},CustomName:'[{"text":"Monk Guillaume","color":"#ffcc00"}]',Health:90,PersistenceRequired:1b,Tags:["villager","guillaume"],Attributes:[{Name:"generic.max_health",Base:90f},{Name:"generic.movement_speed",Base:0f}]}

kill @e[type=armor_stand,tag=spawngrimgar_villager]
kill @e[type=armor_stand,tag=spawngrimgar_trader]
kill @e[type=armor_stand,tag=spawngrimgar]

kill @e[type=armor_stand,tag=grimgar_death]

execute as @e[type=villager,tag=guillaume] run say Thank the gods, finally we can return to our monastery.
scoreboard objectives remove evoker_kill