####Fight

execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:tipped_arrow",tag:{witchcraft:1b}}]}] at @s run function gd:boss_fight/marrow/cursed

execute as @p at @s unless entity @e[type=armor_stand,tag=spawnmarrowbox,distance=..30] run function gd:boss_fight/marrow/marrow_cleanup
execute as @a[scores={marrow_phase2=0..}] unless entity @e[type=wither_skeleton,tag=Boss_Marrow] run scoreboard players set @p wither_kill 1

execute unless entity @e[type=minecraft:wither_skeleton,tag=Boss_Marrow,limit=1] run bossbar set fight_marrow players test
execute if entity @e[type=minecraft:wither_skeleton,tag=Boss_Marrow,limit=1] run bossbar set fight_marrow players @a
execute store result bossbar minecraft:fight_marrow value run data get entity @e[type=minecraft:wither_skeleton,limit=1,tag=Boss_Marrow] Health

execute as @e[type=wither_skeleton,tag=Boss_Marrow] at @p if entity @e[type=wither_skeleton,tag=Boss_Marrow,distance=..10] run scoreboard objectives add marrow_time1 minecraft.custom:minecraft.play_time

execute as @a[scores={marrow1=1..}] at @e[type=armor_stand,tag=marrow_wall] run particle dust_color_transition .2 .4 .2 1 .2 .2 .2 ~ ~.5 ~ 1 3 1 0 1 force


#####Phase1

execute as @a[scores={marrow2=10}] at @e[type=armor_stand,tag=spawnmarrowbox] run effect give @a[distance=..60] minecraft:mining_fatigue 999 2 true
execute as @a[scores={marrow2=10}] run scoreboard objectives add skeleton_kill minecraft.killed:minecraft.skeleton
execute as @a[scores={skeleton_kill=30}] run scoreboard objectives add marrow3 minecraft.custom:minecraft.play_time


execute as @a[scores={marrow2=100}] run function gd:boss_fight/marrow/marrow_skeleton_summon
execute as @a[scores={marrow2=147}] run scoreboard players set @a marrow2 0

execute as @a[scores={marrow_phase1=605}] run function gd:boss_fight/marrow/marrow_guard_summon
execute as @a[scores={marrow_phase1=910}] run function gd:boss_fight/marrow/marrow_guard_summon
execute as @a[scores={marrow_phase1=1215}] run function gd:boss_fight/marrow/marrow_guard_summon
execute as @a[scores={marrow_phase1=1620}] run function gd:boss_fight/marrow/marrow_guard_summon




####Phase2
execute as @a[scores={marrow_phase2=1..}] run scoreboard objectives remove marrow_phase1

kill @e[type=wither_skeleton,tag=!Boss_Marrow]
execute as @a[scores={marrow4=10}] at @e[type=armor_stand,tag=spawnmarrowbox] run effect give @a[distance=..60] minecraft:mining_fatigue 999 2 true

execute as @a[scores={marrow4=200}] at @e[type=minecraft:wither_skeleton,tag=Boss_Marrow] run effect give @e[type=minecraft:wither_skeleton,tag=Boss_Marrow] speed 3 2
execute as @a[scores={marrow4=200}] run particle minecraft:sneeze ~ ~1 ~ 0.1 0.1 0.1 0.1 10
execute as @a[scores={marrow4=200}] run playsound minecraft:entity.phantom.death master @p[distance=..20] ~ ~ ~ 30 0.1
execute as @a[scores={marrow4=1050..}] run scoreboard players set @a marrow4 0

execute as @a[scores={marrow_phase2=100..182}] run function gd:boss_fight/marrow/marrow_weaken_shout
execute as @a[scores={marrow_phase2=300..320}] run function gd:boss_fight/marrow/marrow_teleport
execute as @a[scores={marrow_phase2=500..570}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=600..670}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=700..720}] run function gd:boss_fight/marrow/marrow_teleport
execute as @a[scores={marrow_phase2=750..820}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=1000..1047}] run function gd:boss_fight/marrow/marrow_leap

execute as @a[scores={marrow_phase2=1100..1120}] run function gd:boss_fight/marrow/marrow_teleport
execute as @a[scores={marrow_phase2=1165..1185}] run function gd:boss_fight/marrow/marrow_teleport
execute as @a[scores={marrow_phase2=1200..1270}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=1280..1300}] run function gd:boss_fight/marrow/marrow_teleport
execute as @a[scores={marrow_phase2=1400..1447}] run function gd:boss_fight/marrow/marrow_leap
execute as @a[scores={marrow_phase2=1550..1620}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=1600..1670}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=1800..1847}] run function gd:boss_fight/marrow/marrow_leap

execute as @a[scores={marrow_phase2=2000..2082}] run function gd:boss_fight/marrow/marrow_weaken_shout
execute as @a[scores={marrow_phase2=2200..2270}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=2280..2350}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=2500..2547}] run function gd:boss_fight/marrow/marrow_leap
execute as @a[scores={marrow_phase2=2650..2697}] run function gd:boss_fight/marrow/marrow_leap

execute as @a[scores={marrow_phase2=2800..2870}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=2880..2900}] run function gd:boss_fight/marrow/marrow_teleport
execute as @a[scores={marrow_phase2=2900..2970}] run function gd:boss_fight/marrow/marrow_throw_weapon
execute as @a[scores={marrow_phase2=3100..3120}] run function gd:boss_fight/marrow/marrow_teleport
execute as @a[scores={marrow_phase2=3200..3247}] run function gd:boss_fight/marrow/marrow_leap
execute as @a[scores={marrow_phase2=3400..}] run scoreboard players set @a marrow_phase2 0

execute as @a[scores={marrow_weapon_time=50..}] run kill @e[type=armor_stand,tag=throw_weapon1]
execute as @a[scores={marrow_weapon_time=60..}] run kill @e[type=armor_stand,tag=throw_weapon2]
execute as @a[scores={marrow_weapon_time=70..}] run kill @e[type=armor_stand,tag=throw_weapon3]
execute as @a[scores={marrow_weapon_time=70..}] run scoreboard objectives remove marrow_weapon_time

execute as @e[type=armor_stand,tag=spawnmarrowbox] at @s run particle dust_color_transition .2 .3 .0 1 .2 .2 .2 ~ ~3 ~ .2 1 .2 0 30 force
execute as @e[type=armor_stand,tag=spawnmarrowbox] at @s run particle minecraft:ash ~ ~4 ~ 8 6 8 0.1 5
execute at @e[type=armor_stand,tag=spawnmarrowbox] run function gd:signs/green_snake
execute at @e[type=armor_stand,tag=spawnmarrowbox] run tp @e[type=armor_stand,tag=spawnmarrowbox] ~ ~ ~ ~7 ~

execute as @a[scores={marrow_leap_time=47..}] run scoreboard objectives remove marrow_leap_time
execute as @a[scores={marrow_tp_time=20..}] run scoreboard objectives remove marrow_tp_time
execute as @a[scores={marrow_weapon_time=70..}] run scoreboard objectives remove marrow_weapon_time
