
############################## Mobs ##############################

execute as @e[type=item,nbt={Item:{id:"minecraft:paper",tag:{arena_ticket:1b}}}] at @p if entity @e[type=armor_stand,tag=fair_arena,distance=..11] run function gd:mini_boss_fight/fair_challenger_summon

function gd:entities/nether_spawning

execute as @a[scores={companion_time=400..}] run scoreboard objectives remove companion_time

execute as @a[scores={time_trader_reset=12000..}] run scoreboard players set @a time_trader_reset 0
execute as @a[scores={delivery_time2=275..}] run scoreboard objectives remove delivery_time1
execute as @a[scores={delivery_time2=275..}] run scoreboard objectives remove delivery_time2

#####horse/donkey/mule#####

execute as @e[type=horse,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs1:1b}}}] run effect give @s minecraft:speed 2 1 true
execute as @e[type=horse,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs2:1b}}}] run effect give @s minecraft:speed 2 2 true
execute as @e[type=horse,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs3:1b}}}] run effect give @s minecraft:speed 2 3 true
execute as @e[type=donkey,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs1:1b}}}] run effect give @s minecraft:speed 2 1 true
execute as @e[type=donkey,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs2:1b}}}] run effect give @s minecraft:speed 2 2 true
execute as @e[type=donkey,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs3:1b}}}] run effect give @s minecraft:speed 2 3 true
execute as @e[type=mule,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs1:1b}}}] run effect give @s minecraft:speed 2 1 true
execute as @e[type=mule,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs2:1b}}}] run effect give @s minecraft:speed 2 2 true
execute as @e[type=mule,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs3:1b}}}] run effect give @s minecraft:speed 2 3 true
execute as @e[type=skeleton_horse,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs1:1b}}}] run effect give @s minecraft:speed 2 1 true
execute as @e[type=skeleton_horse,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs2:1b}}}] run effect give @s minecraft:speed 2 2 true
execute as @e[type=skeleton_horse,nbt={SaddleItem:{id:"minecraft:saddle",tag:{hs3:1b}}}] run effect give @s minecraft:speed 2 3 true

execute as @e[type=horse,nbt={ArmorItem:{id:"minecraft:leather_horse_armor",tag:{ha1:1b}}}] run effect give @s minecraft:resistance 2 1 true
execute as @e[type=horse,nbt={ArmorItem:{id:"minecraft:iron_horse_armor",tag:{ha2:1b}}}] run effect give @s minecraft:resistance 2 2 true
execute as @e[type=horse,nbt={ArmorItem:{id:"minecraft:golden_horse_armor",tag:{ha3:1b}}}] run effect give @s minecraft:resistance 2 3 true
execute as @e[type=horse,nbt={ArmorItem:{id:"minecraft:diamond_horse_armor",tag:{ha4:1b}}}] run effect give @s minecraft:resistance 2 4 true

####mystical horses

execute as @a[scores={horse=60..}] run scoreboard objectives remove horse
execute as @a[scores={horse1=600..}] run scoreboard objectives remove horse1
execute as @a[scores={horse2=60..}] run scoreboard objectives remove horse2
execute as @a[scores={horse3=600..}] run scoreboard objectives remove horse3
execute as @a[scores={horse4=60..}] run scoreboard objectives remove horse4
execute as @a[scores={horse5=600..}] run scoreboard objectives remove horse5

####Armoreffect####
execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:leather_helmet"},{Slot:102b,id:"minecraft:leather_chestplate"},{Slot:101b,id:"minecraft:leather_leggings"},{Slot:100b,id:"minecraft:leather_boots"}]}] run effect give @s speed 5 0 true

execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:chainmail_helmet"},{Slot:102b,id:"minecraft:chainmail_chestplate"},{Slot:101b,id:"minecraft:chainmail_leggings"},{Slot:100b,id:"minecraft:chainmail_boots"}]}] run effect give @s saturation 5 0 true

execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:iron_helmet"},{Slot:102b,id:"minecraft:iron_chestplate"},{Slot:101b,id:"minecraft:iron_leggings"},{Slot:100b,id:"minecraft:iron_boots"}]}] run effect give @s strength 5 0 true

execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:golden_helmet"},{Slot:102b,id:"minecraft:golden_chestplate"},{Slot:101b,id:"minecraft:golden_leggings"},{Slot:100b,id:"minecraft:golden_boots"}]}] run effect give @s haste 5 0 true

execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:diamond_helmet"},{Slot:102b,id:"minecraft:diamond_chestplate"},{Slot:101b,id:"minecraft:diamond_leggings"},{Slot:100b,id:"minecraft:diamond_boots"}]}] run effect give @s resistance 5 0 true

execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:netherite_helmet"},{Slot:102b,id:"minecraft:netherite_chestplate"},{Slot:101b,id:"minecraft:netherite_leggings"},{Slot:100b,id:"minecraft:netherite_boots"}]}] run effect give @s health_boost 5 0 true

#####Bossfight start#####

execute as @a at @s if entity @e[type=armor_stand,tag=spawngrimgar,limit=1,sort=nearest,distance=..8] run scoreboard objectives add grimgar1 minecraft.custom:minecraft.play_time
execute as @a at @s if entity @e[type=armor_stand,tag=spawnmarrow,limit=1,sort=nearest,distance=..8] run scoreboard objectives add marrow1 minecraft.custom:minecraft.play_time
execute as @a at @s if entity @e[type=armor_stand,tag=spawndevil,limit=1,sort=nearest,distance=..10] run scoreboard objectives add devil1 minecraft.custom:minecraft.play_time
execute as @a at @s if entity @e[type=armor_stand,tag=spawnmorbex,limit=1,sort=nearest,distance=..10] run scoreboard objectives add morbex_text minecraft.custom:minecraft.play_time

execute as @a at @s if entity @e[type=armor_stand,tag=spawnwitchtop,limit=1,sort=nearest,distance=..5] run tp @p @e[type=minecraft:armor_stand,tag=spawnwitch,limit=1,sort=nearest]
execute as @a at @s if entity @e[type=armor_stand,tag=spawnwitch,limit=1,sort=nearest,distance=..10] run scoreboard objectives add witch1 minecraft.custom:minecraft.play_time

############################## Cleanup ##############################

execute as @a[scores={witch_phase2=300..}] run scoreboard objectives remove witch_phase2

##Armorstands/sneak/abilities_scores##

execute as @s[scores={wither_skull_time1=1200..}] run scoreboard players set @s wither_skull_use 0
execute as @s[scores={wither_skull_time1=1200..}] run scoreboard objectives remove wither_skull_time1

execute as @s[scores={starsword_time2=600..}] run scoreboard players set @s dummy_starsword 0
execute as @s[scores={starsword_time2=600..}] run scoreboard objectives remove starsword_time2
scoreboard objectives remove sneak_starsword

execute as @s[scores={nightsword_time=600..}] run scoreboard players set @s dummy_nightsword 5
execute as @s[scores={nightsword_time=600..}] run scoreboard objectives remove nightsword_time
scoreboard objectives remove sneak_nightsword

execute as @s[scores={fangsword_time=600..}] run scoreboard players set @s dummy_fangsword 0
execute as @s[scores={fangsword_time=600..}] run scoreboard objectives remove fangsword_time
scoreboard objectives remove sneak_fangsword

execute as @s[scores={fireball_time=750..}] run scoreboard players set @s dummy_fire_shield 0
execute as @s[scores={fireball_time=750..}] run scoreboard objectives remove fireball_time
scoreboard objectives remove sneak_fire_shield

execute as @s[scores={glowsword_time=600..}] run scoreboard players set @s dummy_glowsword 0
execute as @s[scores={glowsword_time=600..}] run scoreboard objectives remove glowsword_time
scoreboard objectives remove sneak_glowsword

execute as @s[scores={poisondagger_time=300..}] run scoreboard players set @s dummy_poisondagger 0
execute as @s[scores={poisondagger_time=300..}] run scoreboard objectives remove poisondagger_time
scoreboard objectives remove sneak_poisondagger

execute as @s[scores={root_longbow_time=1200..}] run scoreboard players set @s dummy_root_longbow 0
execute as @s[scores={root_longbow_time=1200..}] run scoreboard objectives remove root_longbow_time
scoreboard objectives remove sneak_root_longbow

execute as @s[scores={warbow_time2=1200..}] run scoreboard players set @s dummy_warbow 0
execute as @s[scores={warbow_time2=1200..}] run scoreboard objectives remove warbow_time2
scoreboard objectives remove sneak_warbow

scoreboard objectives remove sneak_luckypick


