scoreboard objectives add classquest minecraft.custom:minecraft.traded_with_villager
scoreboard players add @p classquest 0


execute as @e[type=villager,tag=deliverer] run execute at @s run particle dust_color_transition .1 .7 .9 1 .2 .2 .2 ~ ~1 ~ .1 4 .1 0 20 force

execute as @a[scores={delivery_time1=10}] as @e[type=villager,tag=deliverer] run say Greetings stranger!
execute as @a[scores={delivery_time1=10}] run playsound minecraft:entity.villager.yes player @p ~ ~ ~ 80
execute as @a[scores={delivery_time1=80}] as @e[type=villager,tag=deliverer] run say Seems like you're not from the Lands Beyond.. Welcome!
execute as @a[scores={delivery_time1=140}] as @e[type=villager,tag=deliverer] run say Looking for an adventure? My master pays well, for good work.
execute as @a[scores={delivery_time1=200}] as @e[type=villager,tag=deliverer] run say You can find him at Direwood Keep. I can sell you a map to the castle.
execute as @a[scores={delivery_time1=310}] as @e[type=villager,tag=deliverer] run give @p gold_nugget{gold_coin:1b,Enchantments:[{id:unbreaking,lvl:1}],HideFlags:1,display:{Name:'[{"text":"Gold Coin","color":"gold"}]'}} 1


execute as @a[scores={delivery_time1=310}] as @e[type=villager,tag=deliverer] run say I see you own a gold coin! You can use it to buy a parcel with class goods from me.
execute as @a[scores={delivery_time1=320}] run playsound minecraft:entity.villager.celebrate player @p ~ ~ ~ 80

execute as @a[scores={delivery_time1=450}] as @e[type=villager,tag=deliverer] run say Just come to me, in the next few minutes and equip a class. I'll make a short break.
execute as @a[scores={delivery_time1=550}] as @e[type=villager,tag=deliverer] run say I can also answer a few questions, as long, as I am here.
execute as @a[scores={delivery_time1=24000..}] run scoreboard objectives remove delivery_time1









execute as @a[scores={delivery_time1=600}] as @e[type=villager,tag=deliverer] as @a run tellraw @s {"text":"What are Gold and Silver Coins?","underlined":true,"color":"aqua","clickEvent":{"action":"run_command","value":"/scoreboard objectives add question1 minecraft.custom:minecraft.play_time"}}
execute as @a[scores={question1=1..}] as @e[type=villager,tag=deliverer] run say They are the currency in these lands. They're only obtainable through trading, mining (with special tools), looting dungeons. Although they look like normal gold nuggets, they're not. Nobody will trade with gold nuggets.. Don't try..
execute as @a[scores={question1=1..}] run scoreboard objectives remove question1

execute as @a[scores={delivery_time1=600}] as @e[type=villager,tag=deliverer] as @a run tellraw @s {"text":"Do I have to use these?","underlined":true,"color":"aqua","clickEvent":{"action":"run_command","value":"/scoreboard objectives add question2 minecraft.custom:minecraft.play_time"}}
execute as @a[scores={question2=1..}] as @e[type=villager,tag=deliverer] run say Of course not! You're free to live in the Lands beyond as you wish. BUT you can't acquire items from traders without them.. And with me...
execute as @a[scores={question2=1..}] run scoreboard objectives remove question2

execute as @a[scores={delivery_time1=600}] as @e[type=villager,tag=deliverer] as @a run tellraw @s {"text":"How can I find dungeons?","underlined":true,"color":"aqua","clickEvent":{"action":"run_command","value":"/scoreboard objectives add question3 minecraft.custom:minecraft.play_time"}}
execute as @a[scores={question3=1..}] as @e[type=villager,tag=deliverer] run say Dungeons you ask? They're shattert across the land. Some are big, some small, but all are dangerous. Some dig deep into the ground and hide treasures of weapons, gold and mysterious artifacts.. At Direwood Keep, Eldrid lives. She sells maps to some of them, but don't underestimate them. If i were you, I don't want to see, what lurks deep in these dungeons..
execute as @a[scores={question3=1..}] run scoreboard objectives remove question3

execute as @a[scores={delivery_time1=600}] as @e[type=villager,tag=deliverer] as @a run tellraw @s {"text":"Where do I find special weapons and armor?","underlined":true,"color":"aqua","clickEvent":{"action":"run_command","value":"/scoreboard objectives add question4 minecraft.custom:minecraft.play_time"}}
execute as @a[scores={question4=1..}] as @e[type=villager,tag=deliverer] run say Weapons and armor with special abilities? Some you can find in chests deep within dunegons, big and small. Some creatures and strong beings at the end of dungeons also drop a unique item, which you can trade with Faendal at Direwood Keep for strong and unique items. And some are only craftable. Monk Zaccarius sells books, which describe their creation or reinforcement.
execute as @a[scores={question4=1..}] run scoreboard objectives remove question4

execute as @a[scores={delivery_time1=600}] as @e[type=villager,tag=deliverer] as @a run tellraw @s {"text":"Are there any challenging fights?","underlined":true,"color":"aqua","clickEvent":{"action":"run_command","value":"/scoreboard objectives add question5 minecraft.custom:minecraft.play_time"}}
execute as @a[scores={question5=1..}] as @e[type=villager,tag=deliverer] run say Be cautious! If you see a flickering fog of various colors, be prepared or stay away. Once you're in a fight, there's no going back, until one of you has been defeated..
execute as @a[scores={question5=1..}] run scoreboard objectives remove question5

execute as @a[scores={delivery_time1=600}] as @e[type=villager,tag=deliverer] as @a run tellraw @s {"text":"What are Arcane Nodes? ","underlined":true,"color":"aqua","clickEvent":{"action":"run_command","value":"/scoreboard objectives add question6 minecraft.custom:minecraft.play_time"}}
execute as @a[scores={question6=1..}] as @e[type=villager,tag=deliverer] run say Magical places. They're intersections of magical lines throughout the Lands Beyond. Eons ago, magicians built shrines at these nodes, to practice magic. Some give effects to humble people kneeling there. Until today, i hear about wizards and sorcerers practicing there, but some turned rogue.. People try to stay away from them..
execute as @a[scores={question6=1..}] run scoreboard objectives remove question6

execute as @a[scores={delivery_time1=600}] as @e[type=villager,tag=deliverer] as @a run tellraw @s {"text":"Are there any other special items in these lands?","underlined":true,"color":"aqua","clickEvent":{"action":"run_command","value":"/scoreboard objectives add question7 minecraft.custom:minecraft.play_time"}}
execute as @a[scores={question7=1..}] as @e[type=villager,tag=deliverer] run say Our arcane community has found large differences, compaired to other lands. Full sets of armor give effects to the wearer. You can find saddles and armor for horses, which increases their stats. You can use the stonecutter to cut all types of wood, or craft various plants. You'll find special enchanted books in some dungeons, which you can sell to Monk Zaccarius for more knowledge about reinforcement of items. If you visit the nether dimension, you could come across mystical horses with special abilities. If you want to learn more, about the known dungeons, read the books in Zaccarius library.
execute as @a[scores={question7=1..}] run scoreboard objectives remove question7

execute as @a[scores={delivery_time1=600}] as @e[type=villager,tag=deliverer] as @a run tellraw @s {"text":"I've heard rumors about companions and spellcasters..","underlined":true,"color":"aqua","clickEvent":{"action":"run_command","value":"/scoreboard objectives add question8 minecraft.custom:minecraft.play_time"}}
execute as @a[scores={question8=1..}] as @e[type=villager,tag=deliverer] run say These lands are rich in the arcane. Here and there, you will meet sorcerers or wizards, which hold a few companion casts of various strenght, which follow your into you battles.. For example the Cloud Nomads, but they're hard to fint and easy to overlook. If you're no wizard yet, you can buy single use spells from wizards, which make a impressive look if you ask me. But they're too expensive to use them myself..
execute as @a[scores={question8=1..}] run scoreboard objectives remove question8









execute as @a[scores={delivery_time2=1..}] run scoreboard objectives remove delivery_time1

execute as @a[scores={classquest=1}] at @e[type=villager,tag=deliverer] run scoreboard objectives add delivery_time2 minecraft.custom:minecraft.play_time 

execute as @a[scores={delivery_time2=10}] as @e[type=villager,tag=deliverer] run say I'm happy, that you found a class for you.
execute as @a[scores={delivery_time2=10}] run playsound minecraft:entity.villager.yes player @p ~ ~ ~ 80
execute as @a[scores={delivery_time2=80}] as @e[type=villager,tag=deliverer] run say Now my break is over and I'll move on.
execute as @a[scores={delivery_time2=190}] as @e[type=villager,tag=deliverer] run say Maybe we will meet again. You can meet me at Direwood Keep sometimes.
execute as @a[scores={delivery_time2=190}] as @e[type=villager,tag=deliverer] run say I wish you a great journey.
execute as @a[scores={delivery_time2=250}] as @e[type=villager,tag=deliverer] run say Bye!
execute as @a[scores={delivery_time2=250}] run playsound minecraft:entity.villager.celebrate player @p ~ ~ ~ 80

execute as @a[scores={delivery_time2=270}] run execute at @e[type=villager,tag=deliverer] run particle minecraft:poof ~ ~1 ~ 0.1 0.1 0.1 0.1 1000
execute as @a[scores={delivery_time2=275}] run scoreboard players add @p classquest 1


execute as @a[scores={classquest=2..}] run scoreboard objectives remove classquest

execute as @a[scores={delivery_time2=275..}] run tp @e[type=villager,tag=deliverer] ~ ~-400 ~

