############################## tickcheck ##############################

execute as @a[scores={check=20}] run function gd:checktick
execute as @a[scores={check=40..}] run scoreboard players set @a check 0

execute as @a[scores={random=20..}] run scoreboard players set @a random 0

execute as @a[scores={time_datapack_start=1200}] run function gd:mob/datapack_start

execute as @a[scores={time_book=1..}] run function gd:tool/book
############################## Villager ##############################

execute as @a[scores={time_trader_reset=200}] run function gd:mob/reset

execute if entity @a[nbt={SelectedItem:{id:"minecraft:clock",tag:{fair_clock:1b}}}] run function gd:tool/fair_clock

execute if entity @e[type=villager,tag=villager,sort=nearest,limit=1] run function gd:mob/direwoodkeep

############################## Arcane Nodes ##############################

execute if entity @e[type=minecraft:armor_stand,tag=arcane_nodes] run function gd:arcane_nodes/arcane_nodes_test

############################## Items ##############################

#test for place-feature execute if entity @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:iron_sword",tag:{iron_sword:1b}}]}] at @p run function gd:tool/place

#####Evasive Shard#####finished
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:echo_shard",tag:{artifact_2:1b}}]}] run function gd:tool/evasive_shard

#####Cursed Arrow#####finished
execute if entity @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:tipped_arrow",tag:{witchcraft:1b}}]}] run function gd:weapon/cursed_arrow

#####Bonfire#####finished
execute if entity @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:tipped_arrow",tag:{bonfire_arrow:1b}}]}] run function gd:weapon/bonfire_arrow

#####Ender Arrow#####finished
execute if entity @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:tipped_arrow",tag:{ender_arrow:1b}}]}] run function gd:weapon/ender_arrow

#####Fire Arrow#####finished
execute if entity @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:tipped_arrow",tag:{fire_arrow:1b}}]}] run function gd:weapon/fire_arrow

####Sickle####finished
execute as @e[nbt={SelectedItem:{id:"minecraft:golden_hoe",tag:{sickle:1b}}}] run scoreboard objectives add sickle minecraft.custom:minecraft.sneak_time
execute as @e[nbt={SelectedItem:{id:"minecraft:diamond_hoe",tag:{sickle_reinforced:1b}}}] run scoreboard objectives add sickle1 minecraft.custom:minecraft.sneak_time

execute as @e[nbt={SelectedItem:{id:"minecraft:golden_hoe",tag:{sickle:1b}}}] at @s run function gd:tool/sickle/sickle
execute as @e[nbt={SelectedItem:{id:"minecraft:diamond_hoe",tag:{sickle_reinforced:1b}}}] at @s run function gd:tool/sickle/sickle_re

execute if entity @e[type=item,nbt={Item:{id:"minecraft:golden_hoe",tag:{sickle:1b}}}] unless entity @e[type=item,nbt={Item:{id:"minecraft:diamond_hoe",tag:{sickle_reinforced:1b}}}] run function gd:tool/sickle/sickle_charge
execute if entity @e[type=item,nbt={Item:{id:"minecraft:diamond_hoe",tag:{sickle_reinforced:1b}}}] unless entity @e[type=item,nbt={Item:{id:"minecraft:golden_hoe",tag:{sickle:1b}}}] run function gd:tool/sickle/sickle_charge

####Horse Heart####finished
execute if entity @e[type=item,nbt={Item:{id:"minecraft:nether_star",tag:{horse_heart:1b}}}] run function gd:entities/convert

############################## Weapon ##############################

#####Poisondaggerfinished
execute as @a[nbt={SelectedItem:{id:"minecraft:stone_sword",tag:{poisondagger:1b}}}] at @s run function gd:weapon/poison_dagger
execute unless entity @e[nbt={SelectedItem:{id:"minecraft:stone_sword",tag:{poisondagger:1b}}}] as @e[type=armor_stand,tag=poisondaggerx] run function gd:weapon/poison_dagger

#####Root Longbow#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:bow",tag:{root_longbow:1b}}}] at @s run function gd:weapon/root_longbow
execute as @a[nbt={SelectedItem:{id:"minecraft:bow",tag:{root_longbow_reinforced:1b}}}] at @s run function gd:weapon/root_longbow

#####Flicia Shield#####finished
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:shield",tag:{flicia_shield:1b}}]}] at @s run function gd:weapon/flicia_shield
execute as @a[nbt={Inventory:[{Slot:-106b,id:"minecraft:shield",tag:{flicia_shield_reinforced:1b}}]}] at @s run function gd:weapon/flicia_shield_reinforced

#####Witherskull Staff#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick",tag:{wither_skull_staff:1b}}}] at @s run function gd:tool/wither_staff/wither_skull_staff
execute unless entity @a[nbt={SelectedItem:{id:"minecraft:warped_fungus_on_a_stick",tag:{wither_skull_staff:1b}}}] as @a[scores={wither_skull_time1=1..}] at @s run function gd:tool/wither_staff/wither_skull_staff

#####Evoker's Heavy Greatsword#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:diamond_sword",tag:{fangsword:1b}}}] at @s run function gd:weapon/fangsword
execute as @a[nbt={SelectedItem:{id:"minecraft:netherite_sword",tag:{fangsword_reinforced:1b}}}] at @s run function gd:weapon/fangsword_reinforced

#####Sacred Relic Sword#####finished
execute unless entity @a[nbt={SelectedItem:{id:"minecraft:golden_sword",tag:{starsword:1b}}}] as @a[scores={starsword_time=1..}] at @s run function gd:weapon/starsword/starsword
execute unless entity @a[nbt={SelectedItem:{id:"minecraft:diamond_sword",tag:{starsword_reinforced:1b}}}] as @a[scores={starsword_time_re=1..}] at @s run function gd:weapon/starsword/starsword
execute as @e[type=minecraft:armor_stand,tag=starsword_skull] at @e[type=minecraft:armor_stand,tag=starsword_skull,limit=1,sort=random] run function gd:weapon/starsword/starsword_skull
execute as @a[nbt={SelectedItem:{id:"minecraft:golden_sword",tag:{starsword:1b}}}] at @s run function gd:weapon/starsword/starsword
execute as @a[nbt={SelectedItem:{id:"minecraft:diamond_sword",tag:{starsword_reinforced:1b}}}] at @s run function gd:weapon/starsword/starsword

#####Fortune's Chisel#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:iron_pickaxe",tag:{luckypick:1b}}}] at @s run function gd:tool/lucky_pick
execute as @a[nbt={SelectedItem:{id:"minecraft:diamond_pickaxe",tag:{luckypick_reinforced:1b}}}] at @s run function gd:tool/lucky_pick

#####Night's Edge#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:netherite_sword",tag:{night:1b}}}] at @s run function gd:weapon/night_sword/night_sword
execute unless entity @a[nbt={SelectedItem:{id:"minecraft:netherite_sword",tag:{night:1b}}}] run execute as @e[type=armor_stand,tag=crystalx] run function gd:weapon/night_sword/night_sword

#####Poisonsword#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:iron_sword",tag:{poisonsword:1b}}}] run scoreboard objectives add poison minecraft.used:minecraft.iron_sword
execute as @e[scores={poison=1..},nbt={SelectedItem:{id:"minecraft:iron_sword",tag:{poisonsword:1b}}}] at @s run function gd:weapon/poison_sword
execute as @a[nbt={SelectedItem:{id:"minecraft:diamond_sword",tag:{poisonsword_reinforced:1b}}}] run scoreboard objectives add poison2 minecraft.used:minecraft.diamond_sword
execute as @e[scores={poison2=1..},nbt={SelectedItem:{id:"minecraft:diamond_sword",tag:{poisonsword_reinforced:1b}}}] at @s run function gd:weapon/poison_sword

#####Banesword#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:iron_sword",tag:{banesword:1b}}}] run scoreboard objectives add bane minecraft.used:minecraft.iron_sword
execute as @e[scores={bane=1..},nbt={SelectedItem:{id:"minecraft:iron_sword",tag:{banesword:1b}}}] at @s run function gd:weapon/bane_sword
execute as @a[nbt={SelectedItem:{id:"minecraft:diamond_sword",tag:{banesword_reinforced:1b}}}] run scoreboard objectives add bane2 minecraft.used:minecraft.diamond_sword
execute as @e[scores={bane2=1..},nbt={SelectedItem:{id:"minecraft:diamond_sword",tag:{banesword_reinforced:1b}}}] at @s run function gd:weapon/bane_sword

#####Luminous#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:iron_sword",tag:{luminous:1b}}}] at @s run function gd:weapon/glow_sword
execute as @a[nbt={SelectedItem:{id:"minecraft:diamond_sword",tag:{luminous_reinforced:1b}}}] at @s run function gd:weapon/glow_sword_reinforced

#####Morbex Heavy Warbow#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:bow",tag:{warbow:1b}}}] at @s run function gd:weapon/warbow
execute as @a[nbt={SelectedItem:{id:"minecraft:bow",tag:{warbow_reinforced:1b}}}] at @s run function gd:weapon/warbow
execute unless entity @a[nbt={SelectedItem:{id:"minecraft:bow",tag:{warbow:1b}}}] unless entity @a[nbt={SelectedItem:{id:"minecraft:bow",tag:{warbow_reinforced:1b}}}] as @e[type=armor_stand,tag=warbow] run function gd:weapon/warbow

#####Wooden Greatshield#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:shield",tag:{fire_shield:1b}}}] at @s run function gd:weapon/fire_shield
execute unless entity @a[nbt={SelectedItem:{id:"minecraft:shield",tag:{fire_shield:1b}}}] as @a[scores={fireball_time=1..}] at @s run function gd:weapon/fire_shield

#####Floatsword#####finished
execute as @a[nbt={SelectedItem:{id:"minecraft:iron_sword",tag:{floatsword:1b}}}] run scoreboard objectives add float minecraft.used:minecraft.iron_sword
execute as @e[scores={float=1..},nbt={SelectedItem:{id:"minecraft:iron_sword",tag:{floatsword:1b}}}] at @s run function gd:weapon/float_sword

############################## Armor ##############################

#####Steel Armor#####finished
execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:iron_helmet",tag:{steel_helmet:1b}},{Slot:102b,id:"minecraft:iron_chestplate",tag:{steel_chestplate:1b}},{Slot:101b,id:"minecraft:iron_leggings",tag:{steel_leggings:1b}},{Slot:100b,id:"minecraft:iron_boots",tag:{steel_boots:1b}}]}] run function gd:armor/steel_plate
execute as @a[nbt={Inventory:[{Slot:103b,id:"minecraft:diamond_helmet",tag:{steel_helmet_reinforced:1b}},{Slot:102b,id:"minecraft:diamond_chestplate",tag:{steel_chestplate_reinforced:1b}},{Slot:101b,id:"minecraft:diamond_leggings",tag:{steel_leggings_reinforced:1b}},{Slot:100b,id:"minecraft:diamond_boots",tag:{steel_boots_reinforced:1b}}]}] run function gd:armor/steel_plate_reinforced

#####Emberstone Sabatons#####finished
execute as @a[nbt={Inventory:[{Slot:100b,id:"minecraft:iron_boots",tag:{emberstone_sabatons:1b}}]}] run function gd:armor/emberstone_sabatons
execute as @a[nbt={Inventory:[{Slot:100b,id:"minecraft:diamond_boots",tag:{emberstone_sabatons_reinforced:1b}}]}] run function gd:armor/emberstone_sabatons


############################## Reinforcement ##############################
execute if entity @e[type=item,nbt={Item:{tag:{tool:1b}}},limit=1,sort=nearest] run function gd:tool/re_tool/re_split

execute if entity @e[type=item,nbt={Item:{id:"minecraft:iron_hoe"}}] run function gd:tool/re_tool/re_cleanup
execute if entity @e[type=item,nbt={Item:{id:"minecraft:iron_hoe"}}] run function gd:tool/sickle/sickle_creation


############################## Spells ##############################

execute if entity @e[type=armor_stand,tag=spell] run function gd:signs/spells/spell_split

execute as @a[scores={warp_book=0..}] run function gd:signs/spells/warp_book_warp



############################## Mobs ##############################

execute if entity @e[type=#gd:companion,tag=companion] run function gd:entities/companion/companion

execute if entity @e[type=minecraft:horse,tag=infernal] run function gd:entities/horse_split
execute if entity @e[type=minecraft:skeleton_horse,tag=soulsteed] run function gd:entities/horse_split
execute if entity @e[type=minecraft:donkey,tag=ashen] run function gd:entities/horse_split

############################## Bosses ##############################

execute if entity @e[type=armor_stand,tag=boss_marker] at @e[type=armor_stand,tag=boss_marker,limit=1,sort=nearest] run function gd:boss_fight/boss_split












